setlocal
call Make-Settings.bat

cd %BASE_DIR%
echo off

rem Create and copy fixes
call :fix atr\fixes\BONUS\Noter           README    README.xex   atr\files\BONUS          $2000
call :fix atr\fixes\BONUS\Noter           REALTIME  REALTIME.xex atr\files\BONUS          $2000
call :fix atr\fixes\BONUS\Undesigned      UNDES     UNDES.xex    atr\files\BONUS          $2000

call :fix atr\fixes\DEMO\AD6502           AD6502    AD6502.xex   atr\files\DEMO\AD6502
call :fix atr\fixes\DEMO\AD6502           XAUTORUN  XAUTORUN.ad6 atr\files
call :fix atr\fixes\DEMO\LMS_CP           LMS_CP    LMS_CP.xex   atr\files\DEMO
call :fix atr\fixes\DEMO\NEAR             NEAR      NEAR.xex     atr\files\DEMO
call :fix atr\fixes\DEMO\VANTAGE          VANTAGE   VANTAGE.xex  atr\files\DEMO

call :fix atr\fixes\GFX\VBXE\COMPOFIL     COMPOFIL  COMPOFIL.xex atr\files\GFX\VBXE
call :fix atr\fixes\GFX\VBXE\KOSTUCHA     KOSTUCHA  KOSTUCHA.xex atr\files\GFX\VBXE
call :fix atr\fixes\GFX\VBXE\SEADEVIL     SEADEVIL  SEADEVIL.xex atr\files\GFX\VBXE
call :fix atr\fixes\GFX\VBXE\WANDIWI2     WANDIWI2  WANDIWI2.xex atr\files\GFX\VBXE

call :fix atr\fixes\INTRO256\DITHER       DITHER    DITHER.xex   atr\files\INTRO256
call :fix atr\fixes\INTRO256\STRIPES      STRIPES   STRIPES.xex  atr\files\INTRO256
call :fix atr\fixes\INTRO256\WAVY256B     WAVY256B  WAVY256B.xex atr\files\INTRO256

call :fix atr\fixes\INTRO16K\DWADE        DWADE     DWADE.xex    atr\files\INTRO16K
call :cpy atr\fixes\INTRO16K\FIRSTIE\FIRSTIE.*                   atr\files\INTRO16K
call :fix atr\fixes\INTRO16K\LOTHAREK     LOTHAREK  LOTHAREK.xex atr\files\INTRO16K       $2000
call :cpy atr\fixes\INTRO16K\TLB\TLB.xex                         atr\files\INTRO16K
call :fix atr\fixes\INTRO16K\TORCH1K      TORCH1K   TORCH1K.xex  atr\files\INTRO16K

call :fix atr\fixes\MSX\GTIA              DARKMATT  DARKMATT.xex atr\files\MSX\GTIA
call :fix atr\fixes\MSX\GTIA              FLYINGMI  FLYINGMI.xex atr\files\MSX\GTIA
call :fix atr\fixes\MSX\GTIA              HYPERDRI  HYPERDRI.xex atr\files\MSX\GTIA
call :fix atr\fixes\MSX\GTIA              INCANTAT  INCANTAT.xex atr\files\MSX\GTIA
call :fix atr\fixes\MSX\GTIA              LEMONCHI  LEMONCHI.xex atr\files\MSX\GTIA
call :fix atr\fixes\MSX\GTIA              REVERIES  REVERIES.xex atr\files\MSX\GTIA
call :fix atr\fixes\MSX\GTIA              THENIGHT  THENIGHT.xex atr\files\MSX\GTIA

call :fix atr\fixes\WILD\GRU              GRU       GRU.xex      atr\files\WILD\GRU

goto :eof

rem Compile fix, clear directory and copy fix
:fix
echo Fixing %1 %2 %3
if exist %1 goto :fix_exists
echo ERROR: %1 does not exist
exit

:fix_exists 
pushd %1
%MADS% -s %2.asm -o:%3
if ERRORLEVEL 1 goto :mads_error
del /S/Q *.lab   2> NUL
del /S/Q *.lst   2> NUL
del /S/Q *.atdbg 2> NUL
popd

rem If a start address is specified, file is packed instead of being copied.
if x==x%5 (
  call :cpy %1\%3 %4\%3
) else (
  %EXOMIZER% sfx %5 %1\%3 -t 168 -o %4\%3 -q
  if ERRORLEVEL 1 goto :exomizer_error
  if NOT ERRORLEVEL 0 goto :exomizer_error
)

rem If there is a matching .txt file, it is copied as well
if exist %1\%2.txt call :cpy %1\%2.txt %4\%2.txt
goto :eof

rem Copy single file
:cpy
echo Copying %1 to %2
copy /Y %1 %2 > NUL
if NOT ERRORLEVEL 0 goto :copy_error
goto :eof

:mads_error
echo ERROR: MADS compilation errors occurred. Check error messages above.
exit

:exomizer_error
echo ERROR: Exomizer errors occurred. Check error messages above.
exit

:copy_error
echo ERROR: Copy errors occurred. Check error messages above.
exit