; The Lost Bytes (TLB)
; Silly Venture 2014, 16k intro
; 2015-01-16, F#READY

; revision history:
;
; sillydemo - 2016-11-06, JAC!
; add BASIC disabling code to loader
; removed setting COLDST
; added fille mode to get one big main segment that can be packaed with SuperPacker/Exomizer
;
; sillydemo - 2015-01-16
; removed dead code, code style cleanup
;
; sillydemo - 2014-11-29
; no NTSC message, screen off while loading
;
; sillydemo - 2014-11-28
; startup 'silly venture 2k14' screen
;
; sillydemo - 2014-11-24
; include musix from Wieczor (Bart)
;
; sillydemo - 2014-11-19
; activate scroll fx by 128 bit in scroller
;
; sillydemo3 - 2014-10-28
; removed landscape for now
;
; sillydemo2 - 2014-10-27
; Added a hardcoded 'wave' to try vertical wave on megadeth
; Looking good! :-)
;
; 6.0 - 2014-10-21
; changed double line scroll to single
; use vscrol bug to duplicate lines
; test with VSCROL values with CONSOL
; 
; 5.0 - 2014-10-20 
; working version with mode 15 scanlines instead of char.mode
;
; 3.0 - 1992-04-16 - FRANKENSTEIN (WHO ELSE?)
	
	opt f-
	org $0600

before_loading
	lda $d014
	and #14
	beq is_pal
	ldy #0
no_ntsc
	lda no_ntsc_text,y
	sta (88),y
	iny
	cpy #23
	bne no_ntsc
fail	jmp fail
is_pal
	lda #0
	sta 559
	lda #1
;	sta COLDST
	sta $220
wait_frame
	lda $220
	bne wait_frame
	mva #$ff $d301	;Disable BASIC while loading
	rts

no_ntsc_text
	dta d'NTSC not supported! :-('
	
	ini before_loading

;*
;* RMT FEATures definitions file
;* For optimizations of RMT player routine to concrete RMT modul only
; generated during module export

	icl "rmt_feat.a65"

;------------------------------------
; including player
; PLAYER entry is set to $2400 but it takes PLAYER - $03C0 yet so effectively 
; it takes space from $2040 
; PLAYER must be set to beginning of page

	icl "rmtplayr.a65"

;-- end of music stuff --

music	= $2850  ; that's address of RMT module 

	org music
	ins "htt14.rmt",+6

          org $6800

MEGADETH  ins 'MEGAFONT.DAT'

; HUH! I FORGOT THE SPACE CHAR! NO PROBLEM.... 14*32 EMPTY BYTES!

          dta d'                                '
          dta d'                                '
          dta d'                                '
          dta d'                                '
          dta d'                                '
          dta d'                                '
          dta d'                                '

          dta d'                                '
          dta d'                                '
          dta d'                                '
          dta d'                                '
          dta d'                                '
          dta d'                                '
SPC       dta d'                                '

; BLANK SPACE
ZEROBUF   	= $0600           ;(48 BYTES)

; SCREEN MEMORY FOR MEGADETH
SCRMEM    	= $4000  ; 32 x 48 x 2 bytes = 3 KB ( end $4BFF )
SCREND    	= $4C00

SCRL		= $F2   ; and $F3
ERAS		= $F4   ; and $F5
ZPTR		= $F6	; and $F7
temp_char 	= $f8
char_idx  	= $f9
mask_idx  	= $fa

; LABELS
VDSLST    	= 512
CDTMV5	  	= 544	; and 545
SDMCTL    	= 559
SDLSTL    	= 560
COLDST    	= 580
GPRIOR    	= 623

PCOLR0    	= 704
PCOLR1    	= 705
PCOLR2    	= 706
PCOLR3    	= 707
COLOR4    	= 712
CHACT     	= 755
CHBAS     	= 756

CONSOL    	= $D01F

CHACTL    	= $D401
HSCROL    	= $D404
VSCROL    	= $D405
WSYNC     	= $D40A
NMIEN     	= $D40E

CHARSET	  	= $E000
XITVBV    	= $E462

; THE PROGRAM, METAL MANIA!

	.align $0400

METALMAN
	jsr SPINIT

        lda #0
        sta wave_index
        sta wave_start
        sta fx_state
        sta fx_number
        
        lda #<dli_first_fx
        sta dli_fx_vector
        lda #>dli_first_fx
        sta dli_fx_vector+1

;        lda #1
;        sta COLDST

	lda #0
	sta VSCROL

        lda #63
        sta SDMCTL

        lda #0
        sta COLOR4

        lda #>CHARSET
        sta CHBAS

        lda #128	; graphics 10
        sta GPRIOR

        lda #7
        ldy #<VBI
        ldx #>VBI
        jsr $E45C

        lda #<display_list
        sta SDLSTL
        lda #>display_list
        sta SDLSTL+1

        lda #<DLI2
        sta VDSLST
        lda #>DLI2
        sta VDSLST+1

        lda #$C0
        sta NMIEN

; now start the real fun!

; player initialisation
        ldx #<music
        ldy #>music
        lda #0
        jsr rmt_init ; init music

	lda #100
	jsr delay_jiffies

        jsr intro_start

stay   	jmp stay           ; WOOF WOOF!

;-------------------------------- DLI --------------------------------

DLI2    pha

        lda SMT
        sta WSYNC
        sta HSCROL
        lda #2
        sta CHACTL

        lda #0
        sta WSYNC	  
		
	lda gtia_colors
	sta $D013
	lda gtia_colors+1
	sta $D014
	lda gtia_colors+2
	sta $D015
	lda gtia_colors+3
	sta $D016
	lda gtia_colors+4
	sta $D017
	lda gtia_colors+5
	sta $D018
	lda gtia_colors+6
	sta $D019	  
	
	lda #0
	sta $D012
	
        lda dli_fx_vector
        sta VDSLST
        lda dli_fx_vector+1
        sta VDSLST+1
        pla
        rti

; dli for first fx
dli_first_fx
	pha
	sta WSYNC
	lda #13	  
	sta VSCROL
	lda #0
	sta VSCROL
	
	txa
	pha
add_color_vector
	jmp dli_end_fx	

; dli for wavy color fx
dli_wavy_color
	pha
	sta WSYNC
vscrol_lda
	lda #1	  
	sta VSCROL
	lda #0
	sta VSCROL
	
        txa
        pha
        
        ldx wave_index
        lda megadeth_wave,X
        sta vscrol_lda+1
        eor#15	; vscrol 15 = 1 extra, 1 = 15 extra lines added
        clc
        adc sum_extra_lines
        sta sum_extra_lines
        inx 
        cpx #(metadeth_wave_end-megadeth_wave)	;MAX_WAVE_COUNT
        bne next_wave
        
        ldx #0
next_wave
        stx wave_index

; color fx
dli_add_colors

next_col1
	lda #$02
	sta $D013
	clc
	adc #$10
	sta next_col1+1
	  
next_col2
	lda #$04
	sta $D014
	clc
	adc #$10
	sta next_col2+1
	   
next_col3
	lda #$06
	sta $D015
	clc
	adc #$10
	sta next_col3+1	   
	   
next_col4
	lda #$08
	sta $D016
	clc
	adc #$10
	sta next_col4+1
	  
next_col5
	lda #$0A
	sta $D017
	clc
	adc #$10
	sta next_col5+1
	  
next_col6
	lda #$0C
	sta $D018
	clc
	adc #$10	  
	sta next_col6+1
	  
next_col7
	lda #$0E
	sta $D019
	clc
	adc #$10
	sta next_col7+1

; end of color fx
	  
dli_end_fx	  	  	  	   
	pla
	tax
	pla
	rti

;------------------------------ MAIN VBI -----------------------------

VBI     jsr SPAZ

        lda #<DLI2
        sta VDSLST
        lda #>DLI2
        sta VDSLST+1
	  
; display part of mega scroll depending on vscrol value
	lda #13
	sta vscrol_lda+1
	  
; move the start position through the wave table
	inc wave_start
	lda wave_start
	cmp #(metadeth_wave_end-megadeth_wave)	;MAX_WAVE_COUNT
	bne no_end_wave
	lda #0
	sta wave_start
no_end_wave
	sta wave_index
	  
; after the DLI calc. we now have the number of added scanlines
; TODO add some lines at the top according to this number?
; reset value to 0 for the next addition
	    
	lda #0
	sta sum_extra_lines

; end of vblank
          
        jsr rmt_play
        jmp XITVBV

; clear megadeth screen memory

clear_screen
	lda #<SCRMEM
        sta ERAS
        lda #>SCRMEM
        sta ERAS+1

        ldy #0
WISSU   lda #0
        sta (ERAS),Y
        iny
        bne WISSU
        inc ERAS+1
        lda ERAS+1
        cmp #>SCREND
        bne WISSU
        rts
        
; write one text line into GTIA mode

write_text_line
	tax
	lda left_margin_table,x
	sta left_margin
	lda text_length_table,x
	sta text_length
	txa
	asl	; x index * 2
	tax
	lda text_pointer,x
	sta text_line+1
	lda screen_start_table,x
	sta screen_start
	inx
	lda text_pointer,x
	sta text_line+2
	lda screen_start_table,x
	sta screen_start+1
	
        ldy #0
        ldx #0
        
put_text
	stx text_pos
	
	lda #5
	jsr delay_jiffies

	txa
	asl
	asl
	clc
	adc screen_start
        sta ERAS
        lda screen_start+1
        adc #0
        sta ERAS+1

text_line
        lda $ffff,x
        sta char_temp+1
        clc
        asl
        asl
        asl
        sta charstart+1
char_temp
        lda #0
        lsr
        lsr
        lsr
        lsr
        lsr
        clc
        adc #>CHARSET
        sta charstart+2

        ldx #0
fill_chars
        stx char_idx
        stx mask_idx
        ldy left_margin
charstart
        lda $ffff,x
        sta temp_char
        rol
        rol
        rol
	jsr write_char
        lda temp_char
        lsr
        lsr
        lsr
        lsr
	jsr write_char
        lda temp_char
	lsr
	lsr
	jsr write_char
        lda temp_char
	jsr write_char

	lda ERAS
	clc
	adc #48*2
	sta ERAS
	lda ERAS+1
	adc #0
	sta ERAS+1
        
	ldx char_idx
	inx
	cpx #8
	bne fill_chars		
    
	lda ERAS
	clc
	adc #4		; next x position in scanline
	sta ERAS
	lda ERAS+1
	adc #0
	sta ERAS+1
	
	lda mask_idx
	clc
	adc #4
	sta mask_idx
	
	ldx text_pos
	inx
	cpx text_length
	beq finish_line
	jmp put_text
finish_line
	rts

write_char
        and #3
	tax
	sty ypos+1
	ldy mask_idx
	lda bits_to_gtia,x
	and mask_gtia,y
ypos	ldy #0        
        sta (ERAS),y
        iny
        inc mask_idx
	rts

delay_jiffies
; delay
	sta CDTMV5
keep_waiting
	lda CDTMV5
	bne keep_waiting
	rts
	
text_pointer
	dta a(silly_text)
	dta a(venture_text)
	dta a(year_text)
	dta a(music_text)
	dta a(wieczor_text)
	dta a(code_text)
	dta a(fready_text)

screen_start_table
	dta a(SCRMEM)
	dta a(SCRMEM + (8 * 96))
	dta a(SCRMEM + (20 * 96))
	dta a(SCRMEM)
	dta a(SCRMEM + (8 * 96))
	dta a(SCRMEM + (16 * 96))
	dta a(SCRMEM + (24 * 96))

text_length_table
	dta 5,7,4
	dta 5,7,4,7

left_margin_table
	dta 14,10,16
	dta 14,10,16,10
	
silly_text
	dta d'SILLY'
venture_text
	dta d'VENTURE'
year_text
	dta d'2k14'

music_text
	dta d'music'
wieczor_text
	dta d'WIECZ0R'
code_text
	dta d'code'
fready_text
	dta d'F#READY'

text_pos
	dta 0
	
; conversion table from 0-3 index bits to GTIA bytes
bits_to_gtia
	dta $00,$0F,$F0,$FF

mask_gtia
	dta $77,$66,$55,$44
	dta $43,$32,$21,$11

	dta $11,$12,$33,$21
	dta $12,$34,$45,$67

	dta $77,$65,$43,$21
	dta $12,$34,$56,$77

	dta $77,$65,$43,$21
	dta $12,$34,$45,$67

	dta $77,$65,$43,$21
	dta $12,$34,$45,$67

	dta $77,$65,$43,$21
	dta $12,$34,$45,$67
	  
; intro start

intro_start
	lda #$30
	jsr set_gtia_colors

	lda #0
	jsr write_text_line
 	lda #1
	jsr write_text_line
 	lda #2
	jsr write_text_line
	
	lda #100
	jsr delay_jiffies
	
	jsr clear_screen

	lda #$90
	jsr set_gtia_colors
	
	lda #3
	jsr write_text_line
	lda #4
	jsr write_text_line	
	lda #5
	jsr write_text_line
	lda #6
	jsr write_text_line	

	lda #150
	jsr delay_jiffies
	
	rts
      
; set GTIA colors for main screen

set_gtia_colors
	tax
	ora #2
	sta gtia_colors
	txa
	ora #4
	sta gtia_colors+1
	txa
	ora #6
	sta gtia_colors+2
	txa
	ora #8
	sta gtia_colors+3
	txa
	ora #10
	sta gtia_colors+4
	txa
	ora #12
	sta gtia_colors+5
	txa
	ora #14
	sta gtia_colors+6
	
	rts

; spaz scroller init.

SPINIT  lda #0
	sta BUFINDEX
	
	jsr clear_screen
	
	;text_line
	jsr MOVEMEGA

; Calculates where the characters from the SPAZ font start in memory

MPOINT  lda #<MEGADETH
        sta ERAS
        lda #>MEGADETH
        sta ERAS+1

        ldx #0
YESIR   lda ERAS
        sta WIDELO,X
        lda ERAS+1
        sta WIDEHI,X

        inx
        lda WIDELO,X
        clc
        adc ERAS
        sta ERAS
        lda WIDEHI,X
        adc ERAS+1
        sta ERAS+1

        cpx #37
        bne YESIR

; fill initial buffers (blank space for megadeth screen)

        ldx #0
        txa
FILL    sta ZEROBUF,X
        inx
        cpx #48
        bne FILL

; INIT. POINTERS

        lda #<SCROLL
        sta SCRL
        lda #>SCROLL
        sta SCRL+1

        jsr NEWCH

        rts
	  
; set megadeth scanline pointers according to current buffer index (0-47)

MOVEMEGA
        lda #<SCRMEM
	clc
	adc BUFINDEX
	sta ERAS
	lda #>SCRMEM
	adc #0
	sta ERAS+1
	
	lda #<MEGAPTR
	sta ZPTR
	lda #>MEGAPTR
	sta ZPTR+1
	
	ldx #0

LINELOOP
        ldy #0
	lda ERAS
	sta (ZPTR),Y	; MEGAPTR index 0
	ldy #3
	sta (ZPTR),Y	; MEGAPTR index 3
	ldy #1
	lda ERAS+1
	sta (ZPTR),Y	; MEGAPTR index 1
	ldy #4
	sta (ZPTR),Y	; MEGAPTR index 4
  
	lda ERAS
	clc
	adc #48*2	; screen width * 2 (for 2 scroll buffers)
        sta ERAS
        lda ERAS+1
        adc #0
        sta ERAS+1
        
        lda ZPTR
        clc
        adc #6	; skip to index + 6
        sta ZPTR
        lda ZPTR+1
        adc #0
        sta ZPTR+1
        
	inx
	cpx #32
	bne LINELOOP

; increase buffer index

	inc BUFINDEX
	lda BUFINDEX
	cmp #48
	bne NEBUF
        lda #0
        sta BUFINDEX

NEBUF   rts

;---------------------- THE MEGADETH SCROLLER! -----------------------

SPAZ
fx_vblank_jmp
	jmp fx_stop_scrolling	; is updated for other scroll fx

; here are the different scroll fx
; fx stop scrolling for a moment

fx_stop_scrolling
	inc time_count
	lda time_count
	bne SLOWDOWN
	inc time_count+1
	lda time_count+1
	cmp #3
	bne SLOWDOWN

set_default_scrolling	
	; end of fx, back to no effects
	lda #<no_effects
	sta fx_vblank_jmp+1
	lda #>no_effects
	sta fx_vblank_jmp+2
	jmp no_effects
	
; start fx wavy colors
fx_wavy_colors
	lda #<dli_wavy_color
	sta dli_fx_vector
	lda #>dli_wavy_color
	sta dli_fx_vector+1
	jmp set_default_scrolling

; start add colors
fx_add_colors
	lda #<dli_add_colors
	sta add_color_vector+1
	lda #>dli_add_colors
	sta add_color_vector+2
	jmp set_default_scrolling

fx_switch_colors
	lda #$D0
	jsr set_gtia_colors
	jmp set_default_scrolling	
	
; no fx default
no_effects
	lda CONSOL
	cmp #6
	bne fast
	
	lda SMT
        eor#2
        sta SMT
        beq SLOWDOWN
fast
        jsr STRIPE
        jsr MOVEMEGA

SLOWDOWN
        rts

; INIT. NEW START,END POINTERS
; OF THE CHARACTER SHAPE DATA!

NEWCH   ldy #0
        lda SPFLAG
        beq NOSPACE
        lda #<SPC
        sta START
        lda #>SPC
        sta START+1
        lda #<(SPC+32)
        sta EIND
        lda #>(SPC+32)
        sta EIND+1
        rts

NOSPACE
        lda (SCRL),Y        ; CHAR.NR
	BPL same_fx
	
; 128 indicates fx switch
	and #$7f
	pha
	
	lda fx_number
	asl
	tax
	lda fx_vblank_ptr,x
	sta fx_vblank_jmp+1
	lda fx_vblank_ptr+1,x
	sta fx_vblank_jmp+2
	  
	inc fx_number
	lda fx_number
	cmp #3		; total number of scroll fx
	bne new_character
	lda #0
	sta fx_number
	
new_character
; continue with the new scroll character
	pla
same_fx
        tax
        lda OFFTAB,X

        tax
        lda WIDELO,X
        sta START
        lda WIDEHI,X
        sta START+1
        inx
        lda WIDELO,X
        sta EIND
        lda WIDEHI,X
        sta EIND+1

; move pointer to next scroll character

        inc SCRL
        bne NEH
        inc SCRL+1
NEH     lda SCRL
        cmp #<SCRLEND
        bne NOGNIE
        lda SCRL+1
        cmp #>SCRLEND
        bne NOGNIE

        lda #<wrap_scroll
        sta SCRL
        lda #>wrap_scroll
        sta SCRL+1

NOGNIE
	rts	

; write a vertical stripe of font data into index 0 for buffer1, buffer2
; buffer1 is located at scrmem + (line * 48 * 2)
; buffer2 is located at scrmem + (line * 48 * 2) + 48

STRIPE
	lda START
        sta LETTER+1
        lda START+1
        sta LETTER+2

	lda #<SCRMEM
	clc
	adc BUFINDEX
	sta ERAS
	lda #>SCRMEM
	adc #0
	sta ERAS+1

        lda #0
        tax

STRALL  ldy #0
LETTER  lda $FFFF,X	; byte from megadeth font stripe (x from 0-31)
	sta (ERAS),Y  ; screen mem. + buffer index (0-47)
	ldy #48
	sta (ERAS),Y  ; screen mem. + buffer index + 48 (48 - 95)
	  
; next scanline
	lda ERAS
	clc
	adc #48*2
	sta ERAS
	lda ERAS+1
	adc #0
	sta ERAS+1
	
        inx
        cpx #32
        bne STRALL

; PAK VOLGENDE 32 BYTES DATA

        lda START
        clc
        adc #32
        sta START
        lda START+1
        adc #0
        sta START+1

; VERGELIJK START EN EIND POINTERS
; ALS ZE GELIJK ZIJN, DAN POINTERS
; OPNIEUW INITIALISEREN.

        lda START
        cmp EIND
        bne NEND
        lda START+1
        cmp EIND+1
        bne NEND

        lda SPFLAG
        eor#1
        sta SPFLAG
        jsr NEWCH

NEND    rts

; WIDE OFFSET OF CHARS (LO)

WIDELO  dta 0
        dta l(16*32)    ; A
        dta l(16*32)    ; B
        dta l(15*32)    ; C
        dta l(16*32)    ; D
        dta l(16*32)    ; E
        dta l(14*32)    ; F
        dta l(14*32)    ; G
        dta l(16*32)    ; H
        dta l( 8*32)    ; I
        dta l(16*32)    ; J
        dta l(16*32)    ; K
        dta l(15*32)    ; L
        dta l(16*32)    ; M
        dta l(16*32)    ; N
        dta l(14*32)    ; O
        dta l(14*32)    ; P
        dta l(15*32)    ; Q
        dta l(16*32)    ; R
        dta l(16*32)    ; S
        dta l(14*32)    ; T
        dta l(16*32)    ; U
        dta l(16*32)    ; V
        dta l(16*32)    ; W
        dta l(16*32)    ; X
        dta l(16*32)    ; Y
        dta l(16*32)    ; Z
        dta l( 5*32)    ; .
        dta l( 5*32)    ; ,
        dta l( 5*32)    ; '
        dta l(10*32)    ; -
        dta l( 8*32)    ; !
        dta l(14*32)    ; ?
        dta l(11*32)    ; (
        dta l(11*32)    ; )
        dta l( 5*32)    ; :
        dta l(14*32)    ; <SPACE>

; WIDE OFFSET OF CHARS (HI)

WIDEHI  dta 0
        dta h( 16*32)    ; A
        dta h( 16*32)    ; B
        dta h( 15*32)    ; C
        dta h( 16*32)    ; D
        dta h( 16*32)    ; E
        dta h( 14*32)    ; F
        dta h( 14*32)    ; G
        dta h( 16*32)    ; H
        dta h(  8*32)    ; I
        dta h( 16*32)    ; J
        dta h( 16*32)    ; K
        dta h( 15*32)    ; L
        dta h( 16*32)    ; M
        dta h( 16*32)    ; N
        dta h( 14*32)    ; O
        dta h( 14*32)    ; P
        dta h( 15*32)    ; Q
        dta h( 16*32)    ; R
        dta h( 16*32)    ; S
        dta h( 14*32)    ; T
        dta h( 16*32)    ; U
        dta h( 16*32)    ; V
        dta h( 16*32)    ; W
        dta h( 16*32)    ; X
        dta h( 16*32)    ; Y
        dta h( 16*32)    ; Z
        dta h(  5*32)    ; .
        dta h(  5*32)    ; ,
        dta h(  5*32)    ; '
        dta h( 10*32)    ; -
        dta h(  8*32)    ; !
        dta h( 14*32)    ; ?
        dta h( 11*32)    ; (
        dta h( 11*32)    ; )
        dta h(  5*32)    ; :
        dta h( 14*32)    ; <SPACE>

OFFTAB  dta 35         ;  0      <SPACE>
        dta 30         ;  1      !
        dta 28         ;  2      " (DISPLAYED AS ')
        dta 0
        dta 0
        dta 0
        dta 0
        dta 0

        dta 32         ;  8      (
        dta 33         ;  9      )
        dta 0
        dta 0
        dta 27         ; 12      ,
        dta 29         ; 13      -
        dta 26         ; 14      .
        dta 0

        dta 0,0,0,0,0,0,0,0

        dta 0
        dta 0
        dta 34         ; 26      :
        dta 0
        dta 0
        dta 0
        dta 0
        dta 31         ; 31      ?

        dta 0
        dta 0          ; 33      A
        dta 1          ; 34      B
        dta 2          ; 35      C
        dta 3          ; 36      D
        dta 4          ; 37      E
        dta 5          ; 38      F
        dta 6          ; 39      G

        dta 7          ; 40      H
        dta 8          ; 41      I
        dta 9          ; 42      J
        dta 10         ; 43      K
        dta 11         ; 44      L
        dta 12         ; 45      M
        dta 13         ; 46      N
        dta 14         ; 47      O

        dta 15         ; 48      P
        dta 16         ; 49      Q
        dta 17         ; 50      R
        dta 18         ; 51      S
        dta 19         ; 52      T
        dta 20         ; 53      U
        dta 21         ; 54      V
        dta 22         ; 55      W

        dta 23         ; 56      X
        dta 24         ; 57      Y
        dta 25         ; 58      Z

; HIER VOLGT EEN DUMMY BYTE!
; ALS HIERDOOR DE UNPACKER GOED WERKT,
; WETEN WE WEER IETS MEER....

        dta 0
        dta 0          ; EN NOG EENTJE

; AUTO BOUNDARY!

        .align $0400

; DISplaY LIST!

display_list

top_empty_lines
	dta 0,0,0,0
	dta 0,0,0,0

	dta 0,0,0,0
	dta 0,0,0,0
	
	dta 48+128          ; DLI2
	dta $70

; MEGADETH scroller, 64 lines (32 x 2)

; 0 - 7
        dta $5F+128	; fx dli ( 8 x )
MEGAPTR dta a(ZEROBUF)
        dta $4F+$30
        dta a(ZEROBUF)

        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)

; 8 - 15
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)

; 16 - 23
vscrol_1
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
vscrol_2 
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)

; 24 - 31
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)

; 32 - 39
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)

; 40 - 47
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)

; 48 - 55
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)

; 56 - 63
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)
        dta $5F+128, a(ZEROBUF), $4F+$30, a(ZEROBUF)

        dta $10+128	; one extra for color shifting

        dta $41
        dta a(display_list)

; SOME VAR. ADDRESSES

START   dta 0,0
EIND    dta 0,0
BUFINDEX
  	dta 0
SMT     dta 0

wave_index
        dta 0
wave_start
	dta 0
sum_extra_lines
        dta 0
fx_state
	dta 0
fx_number
	dta 0
dli_fx_vector
	dta 0,0
time_count
	dta 90,0
SPFLAG
    	dta 0
screen_start
	dta 0,0
left_margin
	dta 0
text_length
	dta 0
gtia_colors
	dta 0,0,0,0
	dta 0,0,0
	
; megadeth vertical wave

megadeth_wave
	dta 13,13,13,13
	dta 13,13,13,13
	
	dta 13,13,13,13
	dta 13,13,13,13
	
	dta 14,14,14,14
	dta 14,14,14,14
	
	dta 14,14,14,14
	dta 15,15,15,15

	dta 15,15,15,15
	dta 14,14,14,14
	
	dta 14,14,14,14
	dta 14,14,14,14
	
	dta 13,13,13,13
	dta 12,12,12,12
	
	dta 12,12,12,12
	dta 13,13,13,13
	
	dta 13
metadeth_wave_end

; fx vblank pointers, indexed by fx_number * 2

fx_vblank_ptr
	dta a(fx_switch_colors)
	dta a(fx_add_colors)
	dta a(fx_wavy_colors)

; SCROLTEXT - USE " INSTEAD OF '

SCROLL	dta d'     '
	dta 128
	dta d'WELCOME TO: "THE LOST BYTES".   A DEMO FOR SILLY VENTURE. '
	dta d'NOW LET"S ADD SOME COLORS TO THIS SCROLLER!   '
	dta 128
	dta d'YEAH! THAT"S MORE LIKE IT. '
	dta d'BUT WE HAVE ONE MORE FX TO ADD...   '
	dta 128
wrap_scroll
	dta d'A NICE WAVY FX WITH COLORS, VERY OLD SKOOL! '
	dta d'THIS IS MY SMALL TRIBUTE TO THE ATARI ST. '
	dta d'I USED THE MEGADETH FONT FROM SPAZ (TLB) IN HONOUR OF '
	dta d'THE GREAT ST DEMOS FROM "THE LOST BOYS". '	
        dta d'SINCE EACH CHARACTER TAKES ABOUT HALF A K'
        dta d'ILOBYTE I DIDN"T INCLUDE NUMBERS TO SAVE MEMORY SPACE! '
        dta d'HELLO TO ALL VISITORS OF "SILLY VENTURE!". HAVE A GREAT PARTY! ' 
        dta d'NOW IT"S TIME FOR THE GREETINX... '
        dta d'PIRX, GREY, MYSTIC BYTES, MIKER, X-RAY, SEBAN, SLIGHT, MAD TEAM, BEWE SOFT, PIMPF, '
        dta d'POKEY SOFT, JAC!, HEAVEN, '
        dta d'THE GATEKEEPER, THE EXTERMINATOR, SOLARSYSTEMS, MR.ATARI, '
        dta d'MRS.ATARI, FM SOFT, SYSOP LOUIS, TML, STEVE ZIPP, STORMTROOPER, NEW BREED SOFT, '
        dta d'THE SCHREURS BROS, ALPHASYS, FRISIAN FOX, HIAS, ABBUC AND ALL OTHER ATARI FRIENDS...  '
        dta d'ENOUGH OF THIS CRAP, LET"S WRAP!     '
        

SCRLEND = *

	opt f-
	run METALMAN
