;
;	>>> In-Memory Low-Loader <<<
;
;	Loads complexe XEX file to high address and then emulates DOS loading.

p1	= zp
l1	= zp+2
p2	= zp+4
p3	= zp+6

runad	= $2e0
iniad	= $2e2

	.proc main
	mva #1 580			;Force cold start, because we only use this if DOS is overwritten
	mwa #file p1
	mwa #[.len file] l1
	mwa #$e477 runad
	mwa #$0000 iniad

segment_loop
	ldy #0
	lda (p1),y
	iny
	and (p1),y
	cmp #$ff
	bne no_header
	jsr get_byte
	jsr get_byte
	jmp segment_loop

no_header
	jsr get_byte
	sta p2
	jsr get_byte
	sta p2+1
	jsr get_byte
	sta p3
	jsr get_byte
	sta p3+1
byte_loop
	jsr get_byte
	sta (p2),y
	cpw p2 p3
	beq segment_end
	inw p2
	jmp byte_loop
segment_end
	lda iniad
	ora iniad+1
	beq no_iniad
	jsr jsr_iniad
no_iniad
	lda l1
	ora l1+1
	bne no_runad
	jsr jsr_runad
	jmp $e477
no_runad
	jmp segment_loop

jsr_iniad
	jmp (iniad)

jsr_runad
	jmp (runad)

	.proc get_byte
	dew l1	;Changes <A>

	ldy #0
	lda (p1),y
	inw p1
	rts
	.endp
	.endp

	run main

